> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/android/event-dispatchers/custom.md).

# Custom

If for some reason, you need to implement your own dispatcher, you must create a `BatchEventDispatcher` and register it to the SDK using `Batch.EventDispatcher.addDispatcher(BatchEventDispatcher)`.

{% hint style="info" %}
You don't need to add a dispatcher if you're using one of the previous "ready-to-go" library ! It will be automatically registered.
{% endhint %}

{% tabs %}
{% tab title="Kotlin" %}

```kotlin
class MyKotlinApplication : Application(), BatchEventDispatcher {

    override fun onCreate() {
        super.onCreate()

        Batch.start("MY_API_KEY")
        registerActivityLifecycleCallbacks(BatchActivityLifecycleHelper())

        // [...]

        Batch.EventDispatcher.addDispatcher(this)
    }

    override fun dispatchEvent(type: Batch.EventDispatcher.Type,
                               payload: Batch.EventDispatcher.Payload) {
        Log.d("Dispatcher", "I'm dispatching : " + type.name)
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
public class MyApplication extends Application implements BatchEventDispatcher {
    @Override
    public void onCreate() {
        super.onCreate();

        Batch.start("MY_API_KEY");
        registerActivityLifecycleCallbacks(new BatchActivityLifecycleHelper());
        
        // [...]

        Batch.EventDispatcher.addDispatcher(this); // add the dispatcher at app start
    }

    @Override
    public void dispatchEvent(@NonNull Batch.EventDispatcher.Type type,
                              @NonNull Batch.EventDispatcher.Payload payload) {
    	Log.d("Dispatcher", "I'm dispatching : " + type.name());
    }
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
If the Batch SDK happens to be opt-out (from the user or because the SDK is opt-out by default), dispatchers won't receive any events.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://doc.batch.com/developer/sdk/android/event-dispatchers/custom.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
